Index: docs/distributions.txt
===================================================================
--- docs/distributions.txt	(revision 6898)
+++ docs/distributions.txt	(working copy)
@@ -2,11 +2,10 @@
 Third-party distributions of Django
 ===================================
 
-Several third-party distributors are now providing versions of Django integrated
-with their package-management systems. These can make installation and upgrading
-much easier for users of Django since the integration includes the ability to
-automatically install dependancies (like database adapters) that Django
-requires.
+Several third-party distributors are now providing versions of Django
+through their package management systems. These can make installation and
+upgrading much easier as the package managers typically include the ability
+to automatically install dependencies that Django requires.
 
 Typically, these packages are based on the latest stable release of Django, so
 if you want to use the development version of Django you'll need to follow the
@@ -18,10 +17,11 @@
 FreeBSD
 =======
 
-The `FreeBSD`_ ports system offers both Django 0.96 (`py-django`_) and a more 
-recent, but not current, version based on Django's trunk (`py-django-devel`_). 
-These are installed in the normal FreeBSD way; for Django 0.96, for example, type: 
-``cd /usr/ports/www/py-django && sudo make install clean``.
+The `FreeBSD`_ ports system offers both Django 0.96.1 (`py-django`_) and a
+more recent, but not current, version based on Django's trunk
+(`py-django-devel`_). These are installed in the normal FreeBSD way; for
+Django 0.96, for example, type: ``cd /usr/ports/www/py-django && sudo make
+install clean``.
 
 .. _FreeBSD: http://www.freebsd.org/
 .. _py-django: http://www.freebsd.org/cgi/cvsweb.cgi/ports/www/py-django/
@@ -34,9 +34,10 @@
 ------
 
 A `packaged version of Django`_ is available for `Debian GNU/Linux`_. Version
-0.95.1 is available in the "stable" repository; Version 0.96 is available in
-the "testing" and "unstable" repositories. Regardless of your chosen repository,
-you can install Django by typing ``apt-get install python-django``.
+0.95.1 is available in the "stable" repository; 0.96.1 is available in
+the "testing" and "unstable" repositories. Regardless of your chosen
+repository, you can install Django by typing ``apt-get install
+python-django`` (typically as root).
 
 When you install this package, ``apt`` will recommend installing a database
 adapter; you should select and install the adapter for whichever database you
@@ -49,10 +50,8 @@
 ------
 
 A Django package is available for `Fedora Linux`_, in the "Fedora Extras"
-repository. The `current Fedora package`_ is based on Django 0.96, and can be
-installed by typing ``yum install Django``. The previous link is for the i386
-binary. Users of other architectures should be able to use that as a starting
-point to find their preferred version.
+repository. The `current Fedora package`_ (for i386) is based on Django 0.96,
+and can be installed by typing ``yum install Django``.
 
 .. _Fedora Linux: http://fedora.redhat.com/
 .. _current Fedora package: http://download.fedora.redhat.com/pub/fedora/linux/extras/6/i386/repoview/Django.html
@@ -60,7 +59,7 @@
 Gentoo
 ------
 
-A Django build is available for `Gentoo Linux`_, and is based on Django 0.96.
+A Django build is available for `Gentoo Linux`_, and is based on Django 0.96.1.
 The `current Gentoo build`_ can be installed by typing ``emerge django``.
 
 .. _Gentoo Linux: http://www.gentoo.org/
@@ -69,13 +68,13 @@
 Ubuntu
 ------
 
-The Debian ``python-django`` package is also available for `Ubuntu Linux`_, in
-the "universe" repository for Ubuntu 7.04 ("Feisty Fawn"). The `current Ubuntu
-package`_ is also based on Django 0.95.1 and can be installed in the same
-fashion as for Debian.
+The ``python-django`` package is available for `Ubuntu Linux`_ - in
+the "universe" repository for Ubuntu 7.10 ("Gutsy Gibbon"). The `current Ubuntu
+package`_ is based on Django 0.96.1 and can be installed in the same way as
+Debian.
 
 .. _Ubuntu Linux: http://www.ubuntu.com/
-.. _current Ubuntu package: http://packages.ubuntu.com/feisty/python/python-django
+.. _current Ubuntu package: http://packages.ubuntu.com/gutsy/python/python-django
 
 
 Mac OS X
@@ -84,17 +83,17 @@
 MacPorts
 --------
 
-Django 0.96 can be installed via the `MacPorts`_ system. If you're using Python 2.4,
-type ``sudo port install py-django-devel``. For Python 2.5, type ``sudo port
-install py25-django-devel``. MacPorts can also be used to install a database,
-and the Python interface to your chosen database.
+If you're using Python 2.4, type ``sudo port install py-django-devel`` for
+Django 0.96. For Python 2.5, type ``sudo port install py25-django-devel`` for
+Django 0.96.1. MacPorts can also be used to install a database, and the Python
+interface to your chosen database.
 
 .. _MacPorts: http://www.macports.org/
 
 For distributors
 ================
 
-If you'd like to package Django for distribution, we'd be happy to help out!
+If you'd like to package Django for distribution we'd be happy to help out!
 Please join the `django-developers mailing list`_ and introduce yourself.
 
 We also encourage all distributors to subscribe to the `django-announce mailing